# Class ProxyRemoteMethod<ReturnType, SourceParameter, TargetParameter>`Abstract`

#### Type Parameters

- ReturnType = any
- SourceParameter = any
- TargetParameter = SourceParameter

#### Hierarchy (View Summary)

- BaseRemoteMethod<ReturnType, SourceParameter>
  - ProxyRemoteMethod

- Defined in packages/angular/remote-method/src/lib/proxy.remote-method.ts:17

#####
Index

### Constructors

constructor

### Properties

__id
_initialised
destroyed$
executed$
executing
executionsInProgress
executionsInProgress$
initialised$
injector
interceptors
metadata
destroyed$
initialised$
instances

### Accessors

id

### Methods

_call
applyMetadata
call
destroy
executed
getMetadata
init
ngOnDestroy
pauseRefresh
refresh
resumeRefresh
transformParameters
add
remove

##
Constructors

### constructor

- new ProxyRemoteMethod<
  ReturnType = any,
  SourceParameter = any,
  TargetParameter = SourceParameter,
  >(
  remoteMethod: BaseRemoteMethod,
  injector?: null | Injector,
  metadata?: BaseRemoteMethodMetadata,
  ): ProxyRemoteMethod<ReturnType, SourceParameter, TargetParameter>

  #### Type Parameters

  - ReturnType = any
  - SourceParameter = any
  - TargetParameter = SourceParameter

  #### Parameters

  - remoteMethod: BaseRemoteMethod
  - injector: null | Injector = null
  - metadata: BaseRemoteMethodMetadata = remoteMethod.metadata

  #### Returns ProxyRemoteMethod<ReturnType, SourceParameter, TargetParameter>

  Overrides BaseRemoteMethod.constructor

  - Defined in packages/angular/remote-method/src/lib/proxy.remote-method.ts:20

##
Properties

### `Internal`__id

__id: string = ...

unique internal id

Inherited from BaseRemoteMethod.__id

- Defined in packages/angular/definition/src/lib/definition.ts:61

### `Protected`_initialised

_initialised: boolean = false

Inherited from BaseRemoteMethod._initialised

- Defined in packages/angular/definition/src/lib/definition.ts:62

### `Readonly` destroyed$

destroyed$: undefined | Subject<void> = ...

Emits if the data source is destroyed

Inherited from BaseRemoteMethod.destroyed$

- Defined in packages/angular/definition/src/lib/definition.ts:48

### executed$

executed$: Subject<ReturnType> = ...

Inherited from BaseRemoteMethod.executed$

- Defined in packages/angular/remote-method/src/lib/base.remote-method.ts:44

### executing

executing: Signal<boolean> = ...

Inherited from BaseRemoteMethod.executing

- Defined in packages/angular/remote-method/src/lib/base.remote-method.ts:50

### executionsInProgress

executionsInProgress: Signal<number> = ...

Inherited from BaseRemoteMethod.executionsInProgress

- Defined in packages/angular/remote-method/src/lib/base.remote-method.ts:48

### executionsInProgress$

executionsInProgress$: CounterSubject = ...

Inherited from BaseRemoteMethod.executionsInProgress$

- Defined in packages/angular/remote-method/src/lib/base.remote-method.ts:46

### `Readonly` initialised$

initialised$: undefined | Subject<void> = ...

Emits if the data source is initialised

Inherited from BaseRemoteMethod.initialised$

- Defined in packages/angular/definition/src/lib/definition.ts:52

### `Readonly` injector

injector: Injector

Inherited from BaseRemoteMethod.injector

- Defined in packages/angular/remote-method/src/lib/base.remote-method.ts:52

### `Readonly` interceptors

interceptors: undefined | Set<Subject<any>> = ...

Inherited from BaseRemoteMethod.interceptors

- Defined in packages/angular/definition/src/lib/definition.ts:53

### metadata

metadata: BaseRemoteMethodMetadata

Inherited from BaseRemoteMethod.metadata

- Defined in packages/angular/definition/src/lib/definition.ts:44

### `Static` `Readonly` destroyed$

destroyed$: Subject<BaseDefinition<BaseDefinitionMetadata>> = ...

Emits when a new Definition instance is initialised

Inherited from BaseRemoteMethod.destroyed$

- Defined in packages/angular/definition/src/lib/definition.ts:41

### `Static` `Readonly` initialised$

initialised$: Subject<BaseDefinition<BaseDefinitionMetadata>> = ...

Emits when a new Definition instance is initialised

Inherited from BaseRemoteMethod.initialised$

- Defined in packages/angular/definition/src/lib/definition.ts:35

### `Static` `Readonly` instances

instances: Map<string, BaseDefinition<BaseDefinitionMetadata>> = ...

A map of active Definition instances

Inherited from BaseRemoteMethod.instances

- Defined in packages/angular/definition/src/lib/definition.ts:27

##
Accessors

### id

- get id(): string

  #### Returns string

  Inherited from BaseRemoteMethod.id

  - Defined in packages/angular/definition/src/lib/definition.ts:87

##
Methods

### `Protected`_call

- _call(parameters?: SourceParameter): Promise<any>

  #### Parameters

  - `Optional` parameters: SourceParameter

  #### Returns Promise<any>

  Overrides BaseRemoteMethod._call

  - Defined in packages/angular/remote-method/src/lib/proxy.remote-method.ts:33

### applyMetadata

- applyMetadata(partialMetadata: Partial<BaseRemoteMethodMetadata>): void

  #### Parameters

  - partialMetadata: Partial<BaseRemoteMethodMetadata>

  #### Returns void

  Inherited from BaseRemoteMethod.applyMetadata

  - Defined in packages/angular/definition/src/lib/definition.ts:111

### call

- call(parameters?: SourceParameter): Promise<ReturnType>

  #### Parameters

  - `Optional` parameters: SourceParameter

  #### Returns Promise<ReturnType>

  Inherited from BaseRemoteMethod.call

  - Defined in packages/angular/remote-method/src/lib/base.remote-method.ts:82

### destroy

- destroy(): void

  #### Returns void

  #### Deprecated

  use ngOnDestroy instead

  Inherited from BaseRemoteMethod.destroy

  - Defined in packages/angular/definition/src/lib/definition.ts:118

### executed

- executed(result: ReturnType): void

  #### Parameters

  - result: ReturnType

  #### Returns void

  Inherited from BaseRemoteMethod.executed

  - Defined in packages/angular/remote-method/src/lib/base.remote-method.ts:95

### getMetadata

- getMetadata(): null | BaseRemoteMethodMetadata

  #### Returns null | BaseRemoteMethodMetadata

  Inherited from BaseRemoteMethod.getMetadata

  - Defined in packages/angular/definition/src/lib/definition.ts:107

### init

- init(): void

  #### Returns void

  Inherited from BaseRemoteMethod.init

  - Defined in packages/angular/definition/src/lib/definition.ts:127

### ngOnDestroy

- ngOnDestroy(): void

  A callback method that performs custom clean-up, invoked immediately before a directive, pipe, or service instance is destroyed.

  #### Returns void

  Inherited from BaseRemoteMethod.ngOnDestroy

  - Defined in packages/angular/definition/src/lib/definition.ts:122

### pauseRefresh

- pauseRefresh(): void

  #### Returns void

  Inherited from BaseRemoteMethod.pauseRefresh

  - Defined in packages/angular/remote-method/src/lib/base.remote-method.ts:101

### refresh

- refresh(): void

  #### Returns void

  Inherited from BaseRemoteMethod.refresh

  - Defined in packages/angular/remote-method/src/lib/base.remote-method.ts:109

### resumeRefresh

- resumeRefresh(): void

  #### Returns void

  Inherited from BaseRemoteMethod.resumeRefresh

  - Defined in packages/angular/remote-method/src/lib/base.remote-method.ts:105

### `Abstract` transformParameters

- transformParameters(
  parameters?: SourceParameter,
  ): TargetParameter | Promise<TargetParameter>

  #### Parameters

  - `Optional` parameters: SourceParameter

  #### Returns TargetParameter | Promise<TargetParameter>

  - Defined in packages/angular/remote-method/src/lib/proxy.remote-method.ts:31

### `Static` add

- add(definition: BaseDefinition): void

  #### Parameters

  - definition: BaseDefinition

  #### Returns void

  Inherited from BaseRemoteMethod.add

  - Defined in packages/angular/definition/src/lib/definition.ts:94

### `Static` remove

- remove(definition: BaseDefinition): void

  #### Parameters

  - definition: BaseDefinition

  #### Returns void

  Inherited from BaseRemoteMethod.remove

  - Defined in packages/angular/definition/src/lib/definition.ts:102